package com.qmth.paper.library.business.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.paper.library.business.entity.PaperScanTask;
import com.qmth.paper.library.business.mapper.PaperScanTaskMapper;
import com.qmth.paper.library.business.service.PaperScanTaskService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 扫描任务表 服务实现类
 * </p>
 */
@Service
public class PaperScanTaskServiceImpl extends ServiceImpl<PaperScanTaskMapper, PaperScanTask> implements PaperScanTaskService {

    @Override
    public List<PaperScanTask> listByPaperArchivesId(Long paperArchivesId) {
        QueryWrapper<PaperScanTask> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(PaperScanTask::getPaperArchivesId, paperArchivesId);
        return this.list(queryWrapper);
    }
}
